// DLaunchDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DLaunch.h"
#include "DLaunchDlg.h"
#include "IntEditDlg.h"
#include "StrEditDlg.h"
#include "ChoiceDlg.h"
#include "ListEditDlg.h"
#include "SettingsDlg.h"

#include <process.h>
#include <io.h>
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDLaunchDlg dialog

CDLaunchDlg::CDLaunchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDLaunchDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDLaunchDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	changed = false;
}

void CDLaunchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDLaunchDlg)
	DDX_Control(pDX, IDC_FILES_LIST, m_filesList);
	DDX_Control(pDX, IDC_LOGOPICTURE, m_logo);
	DDX_Control(pDX, IDC_OPTIONS, m_options);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDLaunchDlg, CDialog)
	//{{AFX_MSG_MAP(CDLaunchDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(NM_CLICK, IDC_OPTIONS, OnClickOptions)
	ON_NOTIFY(NM_RCLICK, IDC_OPTIONS, OnRclickOptions)
	ON_BN_CLICKED(IDC_OPEN_BUTTON, OnOpenButton)
	ON_BN_CLICKED(IDC_SAVE_BUTTON, OnSaveButton)
	ON_LBN_DBLCLK(IDC_FILES_LIST, OnDblclkFilesList)
	ON_BN_CLICKED(IDC_UPDATE_BUTTON, OnUpdateButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDLaunchDlg message handlers

CBitmap logobmp;

BOOL CDLaunchDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString str;
		pSysMenu->AppendMenu(MF_SEPARATOR);
		str.LoadString(IDS_SETTINGSBOX);
		pSysMenu->AppendMenu(MF_STRING, IDM_SETTINGSBOX, str);
		str.LoadString(IDS_ABOUTBOX);
		if (!str.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, str);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CBitmap bmp;

	imglist.Create(14, 14, ILC_MASK, 0, 3);

	bmp.LoadBitmap(IDB_CHECK);
	imglist.Add(&bmp, (COLORREF) 0xffffff);
	bmp.DeleteObject();

	bmp.LoadBitmap(IDB_UNCHECK);
	imglist.Add(&bmp, (COLORREF) 0xffffff);
	bmp.DeleteObject();

	bmp.LoadBitmap(IDB_CHECK);
	imglist.Add(&bmp, (COLORREF) 0xffffff);
	bmp.DeleteObject();

	m_options.SetImageList(&imglist, TVSIL_STATE);

	// If no DLO was specified, see if there is only one to choose from
	// in the current directory.
	if(initialFile == "")
	{
		initialFile = SearchForSingleDLO();
	}
	
	// Load the DLO specified on the command line.
	if(initialFile != "") LoadOptionsFile(initialFile);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDLaunchDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else if((nID & 0xfff0) == IDM_SETTINGSBOX)
	{
		CSettingsDlg dlg;
		dlg.m_textEditor = theApp.TextEditorPath;
		dlg.m_warn = theApp.UpdateWarning;
		dlg.m_closeOnStart = theApp.CloseOnStartGame;
		if(dlg.DoModal() == IDOK)
		{
			theApp.TextEditorPath = dlg.m_textEditor;
			theApp.UpdateWarning = dlg.m_warn;
			theApp.CloseOnStartGame = dlg.m_closeOnStart;
		}
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDLaunchDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDLaunchDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDLaunchDlg::CreateItems(option_t *onlyOf)
{
	int		i;
	
	if(!onlyOf) 
		m_options.DeleteAllItems();
	else
	{
		HTREEITEM handle;
		// Delete all the children of the item.
		while((handle = m_options.GetChildItem(onlyOf->handle)))
			m_options.DeleteItem(handle);
	}
	for(i=0; i<opts.Number(); i++)
	{
		option_t *opt = opts.Get(i);
		if(onlyOf && opt->parent != onlyOf) continue;
		CString str = FormText(opt);
		opt->handle = m_options.InsertItem(str, 0, 0, 
			!opt->parent? TVI_ROOT : opt->parent->handle);
		if(opt->flags & OPF_ENABLED || opt->flags & OPF_DISABLED)
			m_options.SetCheck(opt->handle, (opt->flags & OPF_ENABLED)? TRUE : FALSE);
	}
}

CString CDLaunchDlg::FormText(option_t *opt)
{
	CString buff, str;
	
	buff = opt->text;
	if(opt->flags & OPF_CHOICE)
	{
		str.Format(": %s", opt->choices[(int)opt->value].text);
		buff += str;
		if(opt->flags & OPF_INT_VALUE)
		{
			str.Format(" (%d)", (int) opt->choices[(int)opt->value].value);
			buff += str;
		}
		if(opt->flags & OPF_STR_VALUE)
		{
			char *ptr = opt->choices[(int)opt->value].strValue;
			if(ptr[0])
			{
				str.Format(" (%s)", ptr);
				buff += str;
			}
		}
		return buff;
	}
	if(opt->flags & OPF_INT_VALUE)
	{
		str.Format(": %d", (int) opt->value);
		buff += str;
	}
	if(opt->flags & OPF_STR_VALUE)
	{
		str.Format(": %s", opt->strValue);
		buff += str;
	}	
	return buff;
}

void CDLaunchDlg::OnClickOptions(NMHDR* pNMHDR, LRESULT* pResult) 
{
	POINT mousePos;
	option_t *opt;

	GetCursorPos(&mousePos);
	opt = opts.Get(OptionAtPoint(&mousePos));
	if(opt)
	{
		if(opt->flags & (OPF_ENABLED|OPF_DISABLED))
		{
			opt->flags ^= OPF_ENABLED | OPF_DISABLED;
			m_options.SetCheck(opt->handle, opt->flags&OPF_ENABLED? TRUE : FALSE);
			changed = true;
		}
	}
	
	*pResult = 0;
}


int CDLaunchDlg::OptionAtPoint(LPPOINT screenpnt)
{
	POINT pnt;
	UINT flags;
	memcpy(&pnt, screenpnt, sizeof(pnt));
	m_options.ScreenToClient(&pnt);
	HTREEITEM item = m_options.HitTest(CPoint(pnt), &flags);
	if(item && flags & (TVHT_ONITEM | TVHT_ONITEMRIGHT))
	{
		for(int i=0; i<opts.Number(); i++)
			if(opts.Get(i)->handle == item)
			{
				return i;
			}
	}
	return -1;	
}

void CDLaunchDlg::CheckOption(option_t *opt)
{
	if(opt->flags & OPF_DISABLED) 
	{
		opt->flags ^= (OPF_DISABLED|OPF_ENABLED);
		m_options.SetCheck(opt->handle, TRUE);
		changed = true;
	}
}

void CDLaunchDlg::OnRclickOptions(NMHDR* pNMHDR, LRESULT* pResult) 
{
	POINT mousePos;
	option_t *opt;

	GetCursorPos(&mousePos);
	opt = opts.Get(OptionAtPoint(&mousePos));
	*pResult = 0;
	if(opt)
	{
		// Edit.
		changed = true;
		if(opt->flags & OPF_CHOICE)
		{
			CChoiceDlg dlg;
			dlg.title = opt->text;
			dlg.m_infoText = opt->description;
			dlg.opt = opt;
			dlg.m_selection = (int) opt->value;
			if(dlg.DoModal() == IDOK)
			{
				opt->value = (float) dlg.m_selection;
				m_options.SetItemText(opt->handle, FormText(opt));
				CheckOption(opt);
			}
			return;
		}
		if(opt->flags & OPF_LIST || (opt->parent && opt->parent->flags & OPF_LIST))
		{
			CListEditDlg dlg;
			if(opt->parent && opt->parent->flags & OPF_LIST) 
			{
				dlg.preselect = opt->text;
				opt = opt->parent;
			}
			dlg.title = opt->text;
			dlg.m_infoText = opt->description;
			dlg.containsFiles = opt->flags & OPF_FILE? true : false;
			dlg.opt = opt;
			dlg.optlist = &opts;
			if(dlg.DoModal() == IDOK)
			{
				// Add the new items.
				CreateItems(opt);				
				m_options.Expand(opt->handle, TVE_EXPAND);
			}
			return;
		}
		if(opt->flags & OPF_INT_VALUE)
		{
			// Display the integer edit box.
			CIntEditDlg dlg;
			dlg.title = opt->text;
			dlg.m_value = (int) opt->value;
			dlg.m_infoText = opt->description;
			if(dlg.DoModal() == IDOK)
			{
				opt->value = (float) dlg.m_value;
				// Update!
				CString str = FormText(opt);
				m_options.SetItemText(opt->handle, str);
				CheckOption(opt);
			}
		}
		if(opt->flags & OPF_STR_VALUE)
		{
			if(opt->flags & OPF_FILE)
			{
				CFileDialog dlg(TRUE, NULL, opt->strValue, 
					OFN_HIDEREADONLY|OFN_ENABLESIZING|OFN_FILEMUSTEXIST,
					"All files (*.*)|*.*|Dynamic-link libraries (*.dll)|*.dll|Executables (*.exe)|*.exe|Config files (*.cfg)|*.cfg||");
				if(dlg.DoModal() == IDOK)
				{
					strcpy(opt->strValue, dlg.GetPathName());
					m_options.SetItemText(opt->handle, FormText(opt));
					CheckOption(opt);
				}
			}
			else
			{
				CStrEditDlg dlg;
				dlg.title = opt->text;
				dlg.m_value = opt->strValue;
				dlg.m_infoText = opt->description;
				if(dlg.DoModal() == IDOK)
				{
					strcpy(opt->strValue, dlg.m_value);
					// Update!
					CString str = FormText(opt);
					m_options.SetItemText(opt->handle, str);
					CheckOption(opt);
				}
			}
		}
	}
}

void CDLaunchDlg::OnOK() 
{
	CString	strArgs[128];
	const char *args[128];
	CString str, buff, workdir;
	int		idx = 0;
	option_t *opt;
	
	if(!opts.Number()) return;

	strArgs[idx++] = opts.GetMask(OPF_EXECUTABLE)->strValue;
	
	// See if a working directory is specified.
	opt = opts.GetMask(OPF_WORKING_DIR);
	if(opt)
	{
		char drivestr[_MAX_DRIVE], pathstr[_MAX_PATH], fullstr[_MAX_PATH];
		_fullpath(fullstr, opt->strValue, _MAX_PATH);
		_splitpath(fullstr, drivestr, pathstr, NULL, NULL);
		workdir = CString(drivestr) + pathstr;
	}

	for(int i=0; i<opts.Number(); i++)
	{
		opt = opts.Get(i);
		if(opt->parent)
		{
			// Immediate parent disabled? Must skip.
			if(opt->parent->flags & OPF_DISABLED) continue;
		}
		if(!(opt->flags & OPF_DISABLED))
		{
			if(opt->flags & OPF_LIST && !HasEnabledChildren(opt)) continue;
			if(strlen(opt->option))
			{
				strArgs[idx++] = opt->option;
			}
			if(opt->flags & OPF_INT_VALUE)
			{
				strArgs[idx++].Format("%d ", 
					opt->flags&OPF_CHOICE? (int) opt->choices[(int)opt->value].value 
					: (int) opt->value);
			}
			if(opt->flags & OPF_STR_VALUE)
			{
				strArgs[idx++].Format("%s ", 
					opt->flags&OPF_CHOICE? opt->choices[(int)opt->value].strValue
					: opt->strValue);
			}
		}
		if(idx >= 127)
		{
			idx = 127;
			MessageBox("Too many options!", "Warning");
			break;
		}
	}
	// Build the char* list.
	CString cmdLine;
	for(i=0; i<idx; i++) 
	{
		args[i] = strArgs[i];
		cmdLine += strArgs[i] + " ";
	}
	//MessageBox(cmdLine);
	args[idx] = NULL;

	// Change to the wanted directory.
	if(workdir != "") _chdir(workdir);

	// Execute the command.
	if(_spawnv(_P_DETACH, args[0], args) < 0)
	{
		MessageBox(CString(args[0])+": "+strerror(errno), "Launch Error!", MB_ICONERROR|MB_OK);
		return;
	}

	// Save the current settings.
	opts.SaveTo(dloName);
	changed = false;
	
	if(theApp.CloseOnStartGame) CDialog::OnOK();
}

bool CDLaunchDlg::HasEnabledChildren(option_t *opt)
{
	return opts.HasChildren(opt, OPF_ENABLED);
}

void CDLaunchDlg::LoadOptionsFile(const CString &name)
{
	if(!opts.LoadFrom(name))
		MessageBox("Nothing was loaded!", "Load Error!");
	dloName = name;	
	changed = false;
	UpdateInterface();
}

void CDLaunchDlg::OnOpenButton() 
{
	CFileDialog dlg(TRUE, NULL, NULL, 
			OFN_HIDEREADONLY|OFN_ENABLESIZING|OFN_FILEMUSTEXIST,
			"DLaunch option files (*.dlo)|*.dlo|All files (*.*)|*.*||");

	if(dlg.DoModal() == IDOK)
	{
		AskSave();
		LoadOptionsFile(dlg.GetPathName());
		changed = false;
	}
}

void CDLaunchDlg::OnSaveButton() 
{
	CFileDialog dlg(FALSE, "dlo", dloName, 
			OFN_HIDEREADONLY|OFN_ENABLESIZING|OFN_OVERWRITEPROMPT,
			"DLaunch option files (*.dlo)|*.dlo|All files (*.*)|*.*||");
	
	if(dlg.DoModal() == IDOK)
	{
		opts.SaveTo(dloName = dlg.GetPathName());
		changed = false;
	}
}

void CDLaunchDlg::AskSave()
{
	if(changed && !dloName.IsEmpty())
	{
		if(MessageBox("Do you want to save your changes to\n" + dloName + "?",
			"DLaunch - Unsaved Changes", MB_YESNO | MB_ICONQUESTION) == IDYES)
			opts.SaveTo(dloName);
		changed = false;
	}
}

BOOL CDLaunchDlg::DestroyWindow() 
{
	AskSave();	
	return CDialog::DestroyWindow();
}

CString CDLaunchDlg::SearchForSingleDLO() // in the current directory.
{
	_finddata_t fd;
	long hFile;
	CString candidate;
	
	if((hFile = _findfirst("*.dlo", &fd)) == -1L) return ""; // No DLOs.
	candidate = fd.name;
	while(!_findnext(hFile, &fd))
	{
		// Can't accept: more than one DLO present.
		return "";
	}
	return candidate;
}

void CDLaunchDlg::OnDblclkFilesList() 
{
	CString str;
	
	m_filesList.GetText(m_filesList.GetCurSel(), str);
	if(str == "") return;

	if(_spawnl(_P_NOWAIT, theApp.TextEditorPath, theApp.TextEditorPath, str, NULL) < 0)
	{
		MessageBox(theApp.TextEditorPath + ": " + strerror(errno), 
			"Error Starting Text Editor", MB_ICONERROR | MB_OK);
	}
}

void CDLaunchDlg::OnUpdateButton() 
{
	if(!opts.Number())
	{
		MessageBox("There is nothing to update!", "Updating...", MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	if(theApp.UpdateWarning)
	{
		CString str;
		str.LoadString(IDS_UPDATE_WARNING);
		if(MessageBox(str, "Proceed?", 
			MB_ICONQUESTION | MB_YESNO | MB_DEFBUTTON2) != IDYES) return;		
	}

	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_ENABLESIZING,
		"DLaunch option files (*.dlo)|*.dlo|All files (*.*)|*.*||");
	if(dlg.DoModal() != IDOK) return;

	OptionList updlist;
	updlist.LoadFrom(dlg.GetPathName());
	opts.UpdateWith(updlist);
	// Recreate all the list items.
	CreateItems();
	UpdateInterface();

	changed = true;
}

void CDLaunchDlg::UpdateInterface()
{
	CString wndtitle = "Doomsday Launcher";
	if(opts.title != "")
		wndtitle += " - " + opts.title;
	SetWindowText(wndtitle);
	CreateItems();

	// The logo?
	if(opts.logoBmp != "")
	{
		m_logo.SetWindowPos(0, 11, 11, 0, 0, SWP_NOREDRAW | SWP_NOZORDER | SWP_NOSIZE);
		m_logo.SetBitmap((HBITMAP)LoadImage(NULL, opts.logoBmp, IMAGE_BITMAP, 0, 0, 
			LR_LOADFROMFILE));
		CString str;
		RECT rect;
		m_logo.GetWindowRect(&rect);
		ScreenToClient(&rect);
		int width = rect.right-rect.left, height = rect.bottom-rect.top;
		// Center the image.
		if(width < 160)
		{
			int off = (160-width) / 2;
			rect.left += off;
			rect.right += off;
		}
		if(height < 160)
		{
			int off = (160-height) / 2;
			rect.top += off;
			rect.bottom += off;
		}
		m_logo.MoveWindow(&rect);
	}

	// Put the predefined editable file names into the combo box.
	m_filesList.ResetContent();
	for(POSITION pos = opts.editFiles.GetHeadPosition(); pos;)
		m_filesList.AddString(opts.editFiles.GetNext(pos));

	Invalidate();
}

