// ListEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DLaunch.h"
#include "ListEditDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CListEditDlg dialog


CListEditDlg::CListEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CListEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CListEditDlg)
	m_infoText = _T("");
	//}}AFX_DATA_INIT
}


void CListEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CListEditDlg)
	DDX_Control(pDX, IDC_LIST1, m_list);
	DDX_Text(pDX, IDC_HELPTEXT, m_infoText);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CListEditDlg, CDialog)
	//{{AFX_MSG_MAP(CListEditDlg)
	ON_BN_CLICKED(ID_ADD_BUTTON, OnAddButton)
	ON_BN_CLICKED(ID_REMOVE_BUTTON, OnRemoveButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListEditDlg message handlers

void CListEditDlg::OnAddButton() 
{
	if(containsFiles)
	{
		CFileDialog dlg(TRUE, NULL, NULL, 
				OFN_HIDEREADONLY|OFN_ENABLESIZING|OFN_FILEMUSTEXIST|OFN_ALLOWMULTISELECT,
				"All files (*.*)|*.*|WAD files (*.wad)|*.wad|Config files (*.cfg)|*.cfg|Dynamic-link libraries (*.dll)|*.dll|Executables (*.exe)|*.exe||");
		if(dlg.DoModal() == IDOK)
		{
			POSITION pos = dlg.GetStartPosition();
			// The file will be added.
			while(pos)
			{
				m_list.AddString(dlg.GetNextPathName(pos));
			}
		}
	}
}

void CListEditDlg::OnRemoveButton() 
{
	for(int i=0; i<m_list.GetCount(); i++)
	{
		if(m_list.GetSel(i)) m_list.DeleteString(i--);
	}
}

BOOL CListEditDlg::OnInitDialog() 
{
	int	 i;

	CDialog::OnInitDialog();
	SetWindowText(title);	
	for(i=0; i<optlist->Number(); i++)
	{
		option_t *ptr = optlist->Get(i);
		if(ptr->parent == opt)
		{
			m_list.AddString(ptr->text);
		}
	}
	for(i=0; i<m_list.GetCount(); i++)
	{
		CString str;
		m_list.GetText(i, str);
		if(str == preselect) m_list.SetSel(i);
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CListEditDlg::OnOK() 
{
	// First get rid of the old items.
	optlist->DeleteChildrenOf(opt);
	// Add the new items.
	for(int i=0; i<m_list.GetCount(); i++)
	{
		option_t *ptr = optlist->Add();
		ptr->parent = opt;
		ptr->flags |= OPF_DISABLED;
		m_list.GetText(i, ptr->option);
		strcpy(ptr->text, ptr->option);
	}
	CDialog::OnOK();
}
