// DMaster.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "DMaster.h"

#include "MainFrm.h"
#include "SvListDoc.h"
#include "ServerView.h"
#include "ConfigDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDMasterApp

BEGIN_MESSAGE_MAP(CDMasterApp, CWinApp)
	//{{AFX_MSG_MAP(CDMasterApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_OPTIONS, OnFileOptions)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDMasterApp construction

CDMasterApp::CDMasterApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDMasterApp object

CDMasterApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDMasterApp initialization

BOOL CDMasterApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("SkyJake"));

	LoadStdProfileSettings(0);  // Load standard INI file options (including MRU)

	port = GetProfileInt("Settings", "Port", 10123);

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CServerListDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CServerView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// Initialize jtNet.
	if(jtNetInit(JTNET_SERVICE_TCPIP) != JTNET_OK)
	{
		MessageBox(NULL, "Error initializing jtNet.", "DMaster", MB_ICONERROR | MB_OK);
		return FALSE;
	}

	jtNetSetInteger(JTNET_MASTER_PORT, port);

	// Open the master.
	if(jtNetOpenMaster() != JTNET_OK)
	{
		MessageBox(NULL, "jtNetOpenMaster failed.", "DMaster", MB_ICONERROR | MB_OK);
		return FALSE;
	}

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDMasterApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CDMasterApp message handlers


int CDMasterApp::ExitInstance() 
{
	WriteProfileInt("Settings", "Port", port);

	jtNetShutdown();	
	return CWinApp::ExitInstance();
}

void CDMasterApp::OnFileOptions() 
{
	int oldport = port;
	CConfigDlg dlg;

	dlg.m_ipPort = port;
	if(dlg.DoModal() == IDOK)
	{
		port = dlg.m_ipPort;
		if(oldport != port)
		{
			// Close the master to change port.
			jtNetCloseMaster();
			jtNetSetInteger(JTNET_MASTER_PORT, port);
			if(jtNetOpenMaster() != JTNET_OK)
			{
				MessageBox(NULL, "Error reopening master.", "Changing Port", 
					MB_ICONERROR | MB_OK);
			}
		}
	}
}
