// ServerView.cpp : implementation of the CServerView class
//

#include "stdafx.h"
#include "DMaster.h"

#include "SvListDoc.h"
#include "ServerView.h"

#define TID_HANDLER	14071980
#define TID_UPDATE	2507

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CServerView

IMPLEMENT_DYNCREATE(CServerView, CListView)

BEGIN_MESSAGE_MAP(CServerView, CListView)
	//{{AFX_MSG_MAP(CServerView)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServerView construction/destruction

CServerView::CServerView()
{
	// TODO: add construction code here

}

CServerView::~CServerView()
{
}

BOOL CServerView::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style |= LVS_REPORT;
	return CListView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CServerView drawing

void CServerView::OnDraw(CDC* pDC)
{
	CServerListDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

void CServerView::OnInitialUpdate()
{
	CListCtrl *list = &GetListCtrl();
	list->InsertColumn(0, "Game ID", LVCFMT_LEFT, 100, 0);
	list->InsertColumn(1, "Name", LVCFMT_LEFT, 120, 1);
	list->InsertColumn(2, "Description", LVCFMT_LEFT, 250, 2);
	list->InsertColumn(3, "Players", LVCFMT_LEFT, 50, 3);
	list->InsertColumn(4, "Flags", LVCFMT_LEFT, 50, 4);

	CListView::OnInitialUpdate();

	SetTimer(TID_HANDLER, 200, NULL);
	SetTimer(TID_UPDATE, 3000, NULL);
}

/////////////////////////////////////////////////////////////////////////////
// CServerView diagnostics

#ifdef _DEBUG
void CServerView::AssertValid() const
{
	CListView::AssertValid();
}

void CServerView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}

CServerListDoc* CServerView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CServerListDoc)));
	return (CServerListDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CServerView message handlers

void CServerView::OnTimer(UINT nIDEvent) 
{
	switch(nIDEvent)
	{
	case TID_HANDLER:
		// It's time to handle some master messages.
		jtNetMasterHandler();
		return;

	case TID_UPDATE:
		UpdateServers();
		return;
	}	
	CListView::OnTimer(nIDEvent);
}

void CServerView::UpdateServers()
{
	CListCtrl *list = &GetListCtrl();
	jtnetserver_t info;
	CString str;
	int i, num = jtNetMasterGetServer(0, NULL);

	// Remove previous list contents.
	list->DeleteAllItems();

	for(i=0; i<num; i++)
	{
		if(jtNetMasterGetServer(i, &info) != JTNET_OK) break;

		list->InsertItem(i, info.app, 0);
		list->SetItemText(i, 1, info.name);
		list->SetItemText(i, 2, info.description);
		str.Format("%i / %i", info.players, info.maxPlayers);
		list->SetItemText(i, 3, str);
		str = !info.canJoin? "Lock" : "";
		list->SetItemText(i, 4, str);
	}
}
