#ifndef __JDOOM_SETTINGS_H__
#define __JDOOM_SETTINGS_H__

enum 
{
	HUD_HEALTH,
	HUD_ARMOR,
	HUD_AMMO,
	HUD_KEYS,
	HUD_FRAGS
};

typedef struct jdoom_config_s
{
	int		mouseSensiX/* = 8*/, mouseSensiY/* = 8*/;
	int		dclickuse/* = true*/;
	int		usemlook;		// Mouse look (mouse Y => viewpitch)
	int		usejlook;		// Joy look (joy Y => viewpitch)
	int		alwaysRun;		// Always run.
	int		noAutoAim;		// No auto-aiming?
	int		mlookInverseY;	// Inverse mlook Y axis.
	int		jlookInverseY;	// Inverse jlook Y axis.
	int		showFPS, lookSpring;
	boolean povLookAround/* = false*/;
	int		jumpEnabled/* = false*/;
	int		sbarscale;
	boolean	echoMsg;
	int		lookSpeed;
	float	flashcolor[3];
	int		flashspeed;
	boolean	turningSkull;
	boolean	hudShown[5];	// HUD data visibility.
	float	hudScale;		// How to scale HUD data?
	float	hudColor[3];
	boolean	snd_3D;
	byte	snd_ReverbVolume;	// 0..100.
	boolean reverbDebug;
	boolean moveCheckZ;		// if true, mobjs can move over/under each other.
	float	jumpPower;
	boolean	weaponAutoSwitch;
	boolean	secretMsg;

	// Crosshair.
	int		xhair, xhairSize;
	byte	xhairColor[3];

	// Network.
	boolean	netDeathmatch, netNomonsters, netRespawn, netJumping;
	byte	netEpisode, netMap, netSkill, netSlot;
	byte	netColor;

	int		PlayerColor[MAXPLAYERS];

} jdoom_config_t;

extern jdoom_config_t	cfg;

// Other variables.
extern int	screenblocks;

#endif