// Drawing player sprites.

#include "doomdef.h"
#include "d_config.h"
#include "r_local.h"
#include "r_state.h"
#include "st_stuff.h"


extern float lookOffset;

//
// R_DrawPSprite
//
void R_DrawPSprite (pspdef_t* psp, int idx)
{
/*    fixed_t			tx;
    int				x1;
    int				x2;
    spritedef_t*	sprdef;
    spriteframe_t*	sprframe;
    int				lump;
    boolean			flip;
    vissprite_t*	vis;
    vissprite_t		avis;
    
    // decide which patch to use
#ifdef RANGECHECK
    if ( (unsigned)psp->state->sprite >= numsprites)
	I_Error ("R_ProjectSprite: invalid sprite number %i ",
		 psp->state->sprite);
#endif
    sprdef = &sprites[psp->state->sprite];
#ifdef RANGECHECK
    if ( (psp->state->frame & FF_FRAMEMASK)  >= sprdef->numframes)
	I_Error ("R_ProjectSprite: invalid sprite frame %i : %i ",
		 psp->state->sprite, psp->state->frame);
#endif
    sprframe = &sprdef->spriteframes[ psp->state->frame & FF_FRAMEMASK ];

    lump = sprframe->lump[0];
    flip = (boolean)sprframe->flip[0];
    
    // calculate edges of the shape
    tx = psp->sx-160*FRACUNIT;
	
    tx -= spriteoffset[lump];	
    x1 = (centerxfrac + FixedMul (tx,pspritescale) ) >>FRACBITS;

    // off the right side
    if (x1 > viewwidth) return;		

    tx += spritewidth[lump];
    x2 = ((centerxfrac + FixedMul (tx, pspritescale) ) >>FRACBITS) - 1;

    // off the left side
    if (x2 < 0) return;
    
    // store information in a vissprite
    vis = &avis;
    vis->mobjflags = 0;
    vis->texturemid = (BASEYCENTER<<FRACBITS)+FRACUNIT/2-(psp->sy-spritetopoffset[lump]);
    vis->x1 = x1 < 0 ? 0 : x1;
    vis->x2 = x2 >= viewwidth ? viewwidth-1 : x2;	
    vis->scale = pspritescale<<detailshift;
    
    if (flip)
    {
		vis->xiscale = -pspriteiscale;
		vis->startfrac = spritewidth[lump]-1;
    }
    else
    {
		vis->xiscale = pspriteiscale;
		vis->startfrac = 0;
    }
    
    if (vis->x1 > x1)
		vis->startfrac += vis->xiscale*(vis->x1-x1);

    vis->patch = lump;

    if (viewplayer->powers[pw_invisibility] > 4*32
	|| viewplayer->powers[pw_invisibility] & 8)
    {
		// shadow draw
		vis->colormap = NULL;
    }
    else if (fixedcolormap)
    {
		// fixed color
		vis->colormap = fixedcolormap;
    }
    else if (psp->state->frame & FF_FULLBRIGHT)
    {
		// full bright
		vis->colormap = colormaps;
    }
    else
    {
		// local light
		vis->colormap = spritelights[MAXLIGHTSCALE-1];
    }

    //R_DrawVisSprite (vis, vis->x1, vis->x2);*/

	fixed_t			tx;
	int				x1; 
	spriteinfo_t	sprinfo;
	float			light, alpha;
	int				y;
	boolean			brightshadow = false;

	// Get the sprite info.
	gi.GetSpriteInfo(psp->state->sprite, psp->state->frame, &sprinfo);

	// Calculate edges of the shape.
	tx = psp->sx - (160 + lookOffset*1300) * FRACUNIT;

	tx -= sprinfo.offset;
	x1 = ((160<<FRACBITS)+tx ) >>FRACBITS;
	// Choose color and alpha.
	light = 1;
	alpha = 1;

    if (viewplayer->powers[pw_invisibility] > 4*32
		|| viewplayer->powers[pw_invisibility] & 8)
    {
		// shadow draw
		//vis->colormap = NULL;
		alpha = .4f;
    }
    else if (fixedcolormap)
    {
		// fixed color
		//vis->colormap = fixedcolormap;
    }
    else if (psp->state->frame & FF_FULLBRIGHT)
    {
		// full bright
		//vis->colormap = colormaps;
    }
    else
    {
		// local light
		//vis->colormap = spritelights[MAXLIGHTSCALE-1];
		light = viewplayer->plr->mo->subsector->sector->lightlevel / 255.0;
    }
	y = (psp->sy>>FRACBITS) - (sprinfo.topOffset>>FRACBITS);
	// If the status bar is visible, the sprite is moved up a bit.
	if(gi.Get(DD_VIEWWINDOW_HEIGHT) < 200)
	{
		y -= (ST_HEIGHT*cfg.sbarscale)/(2*20) - 1;
	}
	// Add some extra light.
	light += .1f;	

	/*if(idx == ps_flash)
	{
		brightshadow = true;
		gl.Func(DGL_BLENDING, DGL_SRC_ALPHA, DGL_ONE);
		light = 1;
		alpha = .8f;
	}*/

	// Needs fullbright?
	if((viewplayer->powers[pw_infrared] > 4*32)
		|| (viewplayer->powers[pw_infrared]&8) 
		|| viewplayer->powers[pw_invulnerability] > 30)
	{
		light = 1;
	}

	// Draw it!
	gi.GL_SetColorAndAlpha(light, light, light, alpha);
	gi.GL_DrawPSprite(x1, y, 1, sprinfo.flip, sprinfo.lump);

	if(brightshadow)
	{
		// Restore original blending.
		gl.Func(DGL_BLENDING, DGL_SRC_ALPHA, DGL_ONE_MINUS_SRC_ALPHA);
	}
}


void R_DrawPlayerSprites(ddplayer_t *viewplr)
{
	int			i;
	pspdef_t	*psp;

	viewplayer = (player_t*) viewplr->extradata;
	for (i=0, psp=viewplayer->psprites ; i<NUMPSPRITES ; i++,psp++)
		if(psp->state)
			R_DrawPSprite(psp, i);
}
