// Emacs style mode select   -*- C++ -*- 
//-----------------------------------------------------------------------------
//
// $Id:$
//
// Copyright (C) 1993-1996 by id Software, Inc.
//
// This source is available for distribution and/or modification
// only under the terms of the DOOM Source Code License as
// published by id Software. All rights reserved.
//
// The source is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License
// for more details.
//
// $Log:$
//
// DESCRIPTION:
//	Movement/collision utility functions,
//	as used by function in p_map.c. 
//	BLOCKMAP Iterator functions,
//	and some PIT_* functions to use for iteration.
//
//-----------------------------------------------------------------------------

static const char
rcsid[] = "$Id: p_maputl.c,v 1.5 1997/02/03 22:45:11 b1 Exp $";


#include <stdlib.h>


#include "m_bbox.h"

#include "doomdef.h"
#include "p_local.h"


// State.
#include "r_state.h"


//
// THING POSITION SETTING
//


//
// P_UnsetThingPosition
// Unlinks a thing from block map and sectors.
// On each position change, BLOCKMAP and other
// lookups maintaining lists ot things inside
// these structures need to be updated.
//
void P_UnsetThingPosition (mobj_t* thing)
{
/*    int		blockx;
    int		blocky;
	
    if ( ! (thing->flags & MF_NOSECTOR) )
    {
		// inert things don't need to be in blockmap?
		// unlink from subsector
		if (thing->snext)
			thing->snext->sprev = thing->sprev;
		
		if (thing->sprev)
			thing->sprev->snext = thing->snext;
		else
			thing->subsector->sector->thinglist = thing->snext;
    }
	
    if ( ! (thing->flags & MF_NOBLOCKMAP) )
    {
		// inert things don't need to be in blockmap
		// unlink from block map
		if (thing->bnext)
			thing->bnext->bprev = thing->bprev;
		
		if (thing->bprev)
			thing->bprev->bnext = thing->bnext;
		else
		{
			blockx = (thing->x - bmaporgx)>>MAPBLOCKSHIFT;
			blocky = (thing->y - bmaporgy)>>MAPBLOCKSHIFT;
			
			if (blockx>=0 && blockx < bmapwidth
				&& blocky>=0 && blocky <bmapheight)
			{
				blocklinks[blocky*bmapwidth+blockx] = thing->bnext;
			}
		}
    }*/
	gi.UnlinkThing(thing, 
		(!(thing->flags & MF_NOSECTOR)? DDLINK_SECTOR : 0) |
		(!(thing->flags & MF_NOBLOCKMAP)? DDLINK_BLOCKMAP : 0));
}


//
// P_SetThingPosition
// Links a thing into both a block and a subsector
// based on it's x y.
// Sets thing->subsector properly
//
void
P_SetThingPosition (mobj_t* thing)
{
/*    subsector_t*	ss;
    sector_t*		sec;
    int			blockx;
    int			blocky;
    mobj_t**		link;
	
    
    // link into subsector
    ss = R_PointInSubsector (thing->x,thing->y);
    thing->subsector = ss;
    
    if ( ! (thing->flags & MF_NOSECTOR) )
    {
		// invisible things don't go into the sector links
		sec = ss->sector;
		
		thing->sprev = NULL;
		thing->snext = sec->thinglist;
		
		if (sec->thinglist)
			sec->thinglist->sprev = thing;
		
		sec->thinglist = thing;
    }
	
    
    // link into blockmap
    if ( ! (thing->flags & MF_NOBLOCKMAP) )
    {
		// inert things don't need to be in blockmap		
		blockx = (thing->x - bmaporgx)>>MAPBLOCKSHIFT;
		blocky = (thing->y - bmaporgy)>>MAPBLOCKSHIFT;
		
		if (blockx>=0
			&& blockx < bmapwidth
			&& blocky>=0
			&& blocky < bmapheight)
		{
			link = &blocklinks[blocky*bmapwidth+blockx];
			thing->bprev = NULL;
			thing->bnext = *link;
			if (*link)
				(*link)->bprev = thing;
			
			*link = thing;
		}
		else
		{
			// thing is off the map
			thing->bnext = thing->bprev = NULL;
		}
    }*/
	gi.LinkThing(thing, 
		(!(thing->flags & MF_NOSECTOR)? DDLINK_SECTOR : 0) |
		(!(thing->flags & MF_NOBLOCKMAP)? DDLINK_BLOCKMAP : 0));
}



