
// P_tick.c

#include "DoomDef.h"
#include "P_local.h"
#include "G_game.h"

int leveltime;
int TimerGame;

// This is called at all times, no matter gamestate.
void Plr_Ticker(void)
{
	int	i, count;
	ticcmd_t temp;

	// Clients do not think for themselves.
	if(IS_CLIENT) return;

	// Players get to think away all their buffered cmds.
	for(i=0; i<MAXPLAYERS; i++)
		if(players[i].plr->ingame)
		{
			int ticfound;
			count = 0;
			// Only run cmds when they are available.
			while((ticfound = gi.GetTicCmd(&temp, i)) || demoplayback)
			{
				memcpy(&players[i].cmd, &temp, sizeof(ticcmd_t));
				count++;
			
				/*gi.Message( "P_Tick: cl:%i time:%i found:%i count:%i\n",
				i, leveltime, ticfound, count);*/
				
				// Demos override normal cmds.
				if(demoplayback)
					G_ReadDemoTiccmd(&players[i]);//.cmd);
				
				if(!paused)
				{
					// Since demo playback is synchronous (one cmd per tic)
					// demo recording should be, too.
					if(demorecording)
						G_WriteDemoTiccmd(&players[i].cmd);
				}
				
				// Check for special buttons (pause and netsave).
				G_SpecialButtonThinker(i);
				
				// The player thinks.
				if(gamestate == GS_LEVEL)
				{
					if(!paused) P_PlayerThink(&players[i]);
				}
				
				// When playing back demos, no more than one tic
				// is executed.
				if(demoplayback) break;
			}
		}
}

//----------------------------------------------------------------------------
//
// PROC P_Ticker
//
//----------------------------------------------------------------------------

void P_Ticker(void)
{
	if(!IS_CLIENT)
	{
		if(TimerGame && !paused)
		{
			if(!--TimerGame)
			{
				G_ExitLevel();
			}
		}
	}
	// If the game is paused, nothing will happen.
	if(paused) return;

	P_ClientSideThink();
	
	gi.RunThinkers();
	P_UpdateSpecials();
	P_AmbientSound();
	leveltime++;
}
