#ifndef __DOOMSDAY_SERVER_H__
#define __DOOMSDAY_SERVER_H__

#include "dd_def.h"
#include "jtNetEx.h"

#define SV_WELCOME_STRING "Doomsday "DOOMSDAY_VERSION_TEXT" Server (R2)"

// sv_main.c
void Sv_StartNetGame();
void Sv_PlayerArrives(int newnode);
void Sv_PlayerLeaves(jtnetplayer_t *plrdata);
void Sv_Handshake(int playernum);
void Sv_GetPackets(void);
void Sv_SendText(int to, int con_flags, char *text);
void Sv_FixLocalAngles();
void Sv_Ticker(void);

// sv_frame.c
void Sv_TransmitFrame(void);

// sv_missile.c
void Sv_ScanForMissiles();
void Sv_PackMissiles(int plrNum);

// sv_track.c
void Sv_InitTrackers(void);
void Sv_TextureChanges(int sidenum, int flags);
void Sv_PlaneSound(sector_t *sector, boolean isCeiling, int sound_id, int pace);
void Sv_SectorReport(sector_t *sector, boolean isCeiling, fixed_t dest,
						fixed_t speed, int floorpic);
void Sv_LightReport(sector_t *sector);
void Sv_SendWorldUpdate(int playernum);


#endif